#!/usr/bin/env python
# -*- coding: utf-8 -*-

# CAVEAT UTILITOR
#
# This file was automatically generated by Grako.
#
#    https://pypi.python.org/pypi/grako/
#
# Any changes you make to it will be overwritten the next time
# the file is generated.


from __future__ import print_function, division, absolute_import, unicode_literals
from grako.parsing import graken, Parser


__version__ = (2015, 8, 21, 10, 42, 29, 4)

__all__ = [
    '_atomspecParser',
    '_atomspecSemantics',
    'main'
]


class _atomspecParser(Parser):
    def __init__(self, whitespace=None, nameguard=True, **kwargs):
        super(_atomspecParser, self).__init__(
            whitespace=whitespace,
            nameguard=nameguard,
            comments_re=None,
            eol_comments_re=None,
            **kwargs
        )

    @graken()
    def _atom_specifier_(self):
        with self._choice():
            with self._option():
                self._as_term_()
                self.ast['left'] = self.last_node
                self._token('&')
                self.ast['operator'] = self.last_node
                self._atom_specifier_()
                self.ast['right'] = self.last_node
            with self._option():
                self._as_term_()
                self.ast['left'] = self.last_node
                self._token('|')
                self.ast['operator'] = self.last_node
                self._atom_specifier_()
                self.ast['right'] = self.last_node
            with self._option():
                self._as_term_()
                self.ast['left'] = self.last_node
            self._error('no available options')

        self.ast._define(
            ['left', 'operator', 'right'],
            []
        )

    @graken()
    def _as_term_(self):
        with self._choice():
            with self._option():
                self._token('(')
                self._atom_specifier_()
                self.ast['atomspec'] = self.last_node
                self._token(')')
            with self._option():
                self._token('~')
                self._as_term_()
                self.ast['tilde'] = self.last_node
            with self._option():
                self._selector_name_()
                self.ast['selector'] = self.last_node
            with self._option():
                self._model_list_()
                self.ast['models'] = self.last_node
            self._error('no available options')

        self.ast._define(
            ['atomspec', 'tilde', 'selector', 'models'],
            []
        )

    @graken()
    def _selector_name_(self):
        self._pattern(r'[a-zA-Z_][a-zA-Z0-9_]*')
        self.ast['name'] = self.last_node

        self.ast._define(
            ['name'],
            []
        )

    @graken()
    def _model_list_(self):

        def block0():
            self._model_()
            self.ast.setlist('model', self.last_node)
        self._positive_closure(block0)

        self.ast._define(
            [],
            ['model']
        )

    @graken()
    def _model_(self):
        with self._choice():
            with self._option():
                self._token('##')
                self._attribute_list_()
                self.ast['attrs'] = self.last_node
                with self._optional():
                    self._model_parts_()
                    self.ast['parts'] = self.last_node
                with self._optional():
                    self._zone_selector_()
                    self.ast['zone'] = self.last_node
            with self._option():
                self._token('#')
                self._model_hierarchy_()
                self.ast['hierarchy'] = self.last_node
                with self._optional():
                    self._model_parts_()
                    self.ast['parts'] = self.last_node
                with self._optional():
                    self._zone_selector_()
                    self.ast['zone'] = self.last_node
            with self._option():
                self._model_parts_()
                self.ast['parts'] = self.last_node
                with self._optional():
                    self._zone_selector_()
                    self.ast['zone'] = self.last_node
            self._error('no available options')

        self.ast._define(
            ['attrs', 'parts', 'zone', 'hierarchy'],
            []
        )

    @graken()
    def _model_hierarchy_(self):
        self._model_range_list_()
        self.ast['range_list'] = self.last_node

        def block1():
            self._token('.')
            self._model_range_list_()
            self.ast['hierarchy'] = self.last_node
        self._closure(block1)

        self.ast._define(
            ['range_list', 'hierarchy'],
            []
        )

    @graken()
    def _model_range_list_(self):
        self._model_range_()
        self.ast['range'] = self.last_node

        def block1():
            self._token(',')
            self._model_range_list_()
            self.ast['range_list'] = self.last_node
        self._closure(block1)

        self.ast._define(
            ['range', 'range_list'],
            []
        )

    @graken()
    def _model_range_(self):
        with self._choice():
            with self._option():
                self._model_spec_()
                self.ast['start'] = self.last_node
                self._token('-')
                self._model_spec_()
                self.ast['end'] = self.last_node
            with self._option():
                self._model_spec_()
                self.ast['start'] = self.last_node
            self._error('no available options')

        self.ast._define(
            ['start', 'end'],
            []
        )

    @graken()
    def _model_spec_(self):
        with self._choice():
            with self._option():
                self._pattern(r'[0-9]+')
                self.ast['number'] = self.last_node
            with self._option():
                self._token('*')
                self.ast['star'] = self.last_node
            self._error('expecting one of: * [0-9]+')

        self.ast._define(
            ['number', 'star'],
            []
        )

    @graken()
    def _model_parts_(self):

        def block0():
            self._chain_()
            self.ast.setlist('chain', self.last_node)
        self._positive_closure(block0)

        self.ast._define(
            [],
            ['chain']
        )

    @graken()
    def _chain_(self):
        with self._choice():
            with self._option():
                self._token('//')
                self._attribute_list_()
                self.ast['attrs'] = self.last_node

                def block1():
                    self._residue_()
                    self.ast.setlist('residue', self.last_node)
                self._closure(block1)
            with self._option():
                self._token('/')
                self._part_list_()
                self.ast['parts'] = self.last_node

                def block4():
                    self._residue_()
                    self.ast.setlist('residue', self.last_node)
                self._closure(block4)
            with self._option():

                def block6():
                    self._residue_()
                    self.ast.setlist('residue', self.last_node)
                self._positive_closure(block6)
            self._error('no available options')

        self.ast._define(
            ['attrs', 'parts'],
            ['residue']
        )

    @graken()
    def _residue_(self):
        with self._choice():
            with self._option():
                self._token('::')
                self._attribute_list_()
                self.ast['attrs'] = self.last_node

                def block1():
                    self._atom_()
                    self.ast.setlist('atom', self.last_node)
                self._closure(block1)
            with self._option():
                self._token(':')
                self._part_list_()
                self.ast['parts'] = self.last_node

                def block4():
                    self._atom_()
                    self.ast.setlist('atom', self.last_node)
                self._closure(block4)
            with self._option():

                def block6():
                    self._atom_()
                    self.ast.setlist('atom', self.last_node)
                self._positive_closure(block6)
            self._error('no available options')

        self.ast._define(
            ['attrs', 'parts'],
            ['atom']
        )

    @graken()
    def _atom_(self):
        with self._choice():
            with self._option():
                self._token('@@')
                self._attribute_list_()
                self.ast['attrs'] = self.last_node
            with self._option():
                self._token('@')
                self._part_list_()
                self.ast['parts'] = self.last_node
            self._error('no available options')

        self.ast._define(
            ['attrs', 'parts'],
            []
        )

    @graken()
    def _part_list_(self):
        with self._choice():
            with self._option():
                self._part_range_list_()
                self.ast['range'] = self.last_node
                self._token(',')
                self._part_list_()
                self.ast['part'] = self.last_node
            with self._option():
                self._part_range_list_()
                self.ast['range'] = self.last_node
            self._error('no available options')

        self.ast._define(
            ['range', 'part'],
            []
        )

    @graken()
    def _part_range_list_(self):
        self._pattern(r'-?[a-zA-Z0-9]+')
        self.ast['start'] = self.last_node
        with self._optional():
            self._token('-')
            self._pattern(r'[-a-zA-Z0-9]+')
            self.ast['end'] = self.last_node

        self.ast._define(
            ['start', 'end'],
            []
        )

    @graken()
    def _attribute_list_(self):
        self._attr_test_()

        def block0():
            self._token(',')
            self._attr_test_()
        self._closure(block0)

    @graken()
    def _attr_test_(self):
        with self._choice():
            with self._option():
                self._attr_name_()
                self._attr_operator_()
                self._attr_value_()
            with self._option():
                self._attr_name_()
            with self._option():
                self._token('~')
                self._attr_name_()
            self._error('no available options')

    @graken()
    def _attr_name_(self):
        self._pattern(r'[a-zA-Z_][a-zA-Z0-9_]*')

    @graken()
    def _attr_operator_(self):
        with self._choice():
            with self._option():
                self._token('>=')
            with self._option():
                self._token('>')
            with self._option():
                self._token('<=')
            with self._option():
                self._token('<')
            with self._option():
                self._token('=')
            with self._option():
                self._token('!=')
            with self._option():
                self._token('<>')
            self._error('expecting one of: != < <= <> = > >=')

    @graken()
    def _attr_value_(self):
        self._pattern(r'[^,#/:@ \t]+')

    @graken()
    def _zone_selector_(self):
        self._zone_operator_()
        self._real_number_()

    @graken()
    def _zone_operator_(self):
        with self._choice():
            with self._option():
                self._token('@>=')
            with self._option():
                self._token('@>')
            with self._option():
                self._token('@<=')
            with self._option():
                self._token('@<')
            with self._option():
                self._token(':>=')
            with self._option():
                self._token(':>')
            with self._option():
                self._token(':<=')
            with self._option():
                self._token(':<')
            with self._option():
                self._token('/>=')
            with self._option():
                self._token('/>')
            with self._option():
                self._token('/<=')
            with self._option():
                self._token('/<')
            with self._option():
                self._token('#>=')
            with self._option():
                self._token('#>')
            with self._option():
                self._token('#<=')
            with self._option():
                self._token('#<')
            self._error('expecting one of: #< #<= #> #>= /< /<= /> />= :< :<= :> :>= @< @<= @> @>=')

    @graken()
    def _real_number_(self):
        self._pattern(r'[0-9]*\.?[0-9]+')


class _atomspecSemantics(object):
    def atom_specifier(self, ast):
        return ast

    def as_term(self, ast):
        return ast

    def selector_name(self, ast):
        return ast

    def model_list(self, ast):
        return ast

    def model(self, ast):
        return ast

    def model_hierarchy(self, ast):
        return ast

    def model_range_list(self, ast):
        return ast

    def model_range(self, ast):
        return ast

    def model_spec(self, ast):
        return ast

    def model_parts(self, ast):
        return ast

    def chain(self, ast):
        return ast

    def residue(self, ast):
        return ast

    def atom(self, ast):
        return ast

    def part_list(self, ast):
        return ast

    def part_range_list(self, ast):
        return ast

    def attribute_list(self, ast):
        return ast

    def attr_test(self, ast):
        return ast

    def attr_name(self, ast):
        return ast

    def attr_operator(self, ast):
        return ast

    def attr_value(self, ast):
        return ast

    def zone_selector(self, ast):
        return ast

    def zone_operator(self, ast):
        return ast

    def real_number(self, ast):
        return ast


def main(filename, startrule, trace=False, whitespace=None, nameguard=None):
    import json
    with open(filename) as f:
        text = f.read()
    parser = _atomspecParser(parseinfo=False)
    ast = parser.parse(
        text,
        startrule,
        filename=filename,
        trace=trace,
        whitespace=whitespace,
        nameguard=nameguard)
    print('AST:')
    print(ast)
    print()
    print('JSON:')
    print(json.dumps(ast, indent=2))
    print()

if __name__ == '__main__':
    import argparse
    import string
    import sys

    class ListRules(argparse.Action):
        def __call__(self, parser, namespace, values, option_string):
            print('Rules:')
            for r in _atomspecParser.rule_list():
                print(r)
            print()
            sys.exit(0)

    parser = argparse.ArgumentParser(description="Simple parser for _atomspec.")
    parser.add_argument('-l', '--list', action=ListRules, nargs=0,
                        help="list all rules and exit")
    parser.add_argument('-n', '--no-nameguard', action='store_true',
                        dest='no_nameguard',
                        help="disable the 'nameguard' feature")
    parser.add_argument('-t', '--trace', action='store_true',
                        help="output trace information")
    parser.add_argument('-w', '--whitespace', type=str, default=string.whitespace,
                        help="whitespace specification")
    parser.add_argument('file', metavar="FILE", help="the input file to parse")
    parser.add_argument('startrule', metavar="STARTRULE",
                        help="the start rule for parsing")
    args = parser.parse_args()

    main(
        args.file,
        args.startrule,
        trace=args.trace,
        whitespace=args.whitespace,
        nameguard=not args.no_nameguard
    )
